#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2000one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 2000"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2000one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  

global shot2one20004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 


                 
# -------------------------------------------------------------------------------------------------
# 2000
# -------------------------------------------------------------------------------------------------                                          
shot2one20004xi = {
                  1:'0x0y1999z',
                  2:'0x1324y1498z',
                  3:'0x60y1999z',
                  4:'1012x1455y924z',
                  5:'1025x1101y1317z',
                  6:'1029x775y1529z',
                  7:'102x122y1993z',
                  8:'1050x1301y1097z',
                  9:'1055x712y1542z',
                  10:'1072x1036y1332z',
                  11:'1081x1393y942z',
                  12:'108x143y1991z',
                  13:'1109x1236y1113z',
                  14:'1115x970y1347z',
                  15:'111x165y1990z',
                  16:'112x211y1985z',
                  17:'113x188y1987z',
                  18:'1146x1327y960z',
                  19:'1153x902y1361z',
                  20:'115x1659y1110z',
                  21:'115x246y2082z',
                  22:'1164x1168y1130z',
                  23:'1188x832y1376z',
                  24:'11x16y1999z',
                  25:'1207x1258y977z',
                  26:'1215x1098y1146z',
                  27:'1262x1025y1163z',
                  28:'1264x1187y995z',
                  29:'1305x951y1179z',
                  30:'1317x1112y1012z',
                  31:'132x1510y1304z',
                  32:'135x1286y1525z',
                  33:'1366x1036y1029z',
                  34:'155x1850y743z',
                  35:'183x1773y906z',
                  36:'19x218y1987z',
                  37:'200x1262y1537z',
                  38:'200x1639y1127z',
                  39:'209x1488y1319z',
                  40:'21x33y1999z',
                  41:'251x1832y761z',
                  42:'262x1235y1550z',
                  43:'274x1751y924z',
                  44:'284x1462y1334z',
                  45:'284x1615y1144z',
                  46:'28x1673y1094z',
                  47:'28x197y1990z',
                  48:'29x52y1999z',
                  49:'2x20y1999z',
                  50:'2x40y1999z',
                  51:'322x1205y1563z',
                  52:'345x1808y780z',
                  53:'34x176y1991z',
                  54:'357x1432y1349z',
                  55:'35x71y1998z',
                  56:'364x1726y942z',
                  57:'365x1587y1160z',
                  58:'380x1171y1575z',
                  59:'39x154y1993z',
                  60:'39x91y1997z',
                  61:'41x112y1996z',
                  62:'41x133y1995z',
                  63:'427x1398y1364z',
                  64:'435x1135y1587z',
                  65:'437x1780y798z',
                  66:'444x1554y1176z',
                  67:'451x1695y960z',
                  68:'488x1096y1599z',
                  69:'495x1361y1378z',
                  70:'521x1518y1192z',
                  71:'528x1747y816z',
                  72:'536x1660y977z',
                  73:'537x1055y1611z',
                  74:'53x1527y1289z',
                  75:'560x1320y1393z',
                  76:'583x1011y1623z',
                  77:'596x1477y1208z',
                  78:'59x1863y724z',
                  79:'616x1709y835z',
                  80:'619x1620y994z',
                  81:'622x1277y1407z',
                  82:'627x965y1635z',
                  83:'63x49y1998z',
                  84:'667x1433y1224z',
                  85:'667x918y1646z',
                  86:'682x1230y1421z',
                  87:'68x1307y1512z',
                  88:'699x1576y1012z',
                  89:'701x1667y853z',
                  90:'704x869y1657z',
                  91:'735x1385y1240z',
                  92:'737x1180y1435z',
                  93:'737x818y1668z',
                  94:'75x65y1997z',
                  95:'767x767y1679z',
                  96:'776x1529y1029z',
                  97:'783x1620y871z',
                  98:'790x1128y1449z',
                  99:'794x714y1690z',
                  100:'800x1334y1255z',
                  101:'817x661y1701z',
                  102:'836x608y1711z',
                  103:'839x1074y1463z',
                  104:'849x1477y1046z',
                  105:'862x1280y1271z',
                  106:'863x1569y889z',
                  107:'86x83y1996z',
                  108:'884x1017y1476z',
                  109:'90x1789y889z',
                  110:'920x1223y1286z',
                  111:'920x1422y1063z',
                  112:'926x959y1490z',
                  113:'939x1514y907z',
                  114:'95x102y1995z',
                  115:'964x899y1503z',
                  116:'975x1163y1302z',
                  117:'987x1363y1080z',
                  118:'998x838y1516z',
                  119:'9x239y1985z'}

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2000one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2000one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2000ONE4XI - STARTED TIME: ", time2start)
        #  
        
        print("\n (STEP 1A2/33) OF FIRE2000ONE4XI -  QUEUE2ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2000ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2000ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2000ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE20004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one20004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2000ONE4XI - SUCCEEDED TO PUT SHOT2ONE20004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE20004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time  
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2000ONE4XI *** FAILED TO PUT SHOT2ONE20004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2000ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        #
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one20004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one20004xi</nack2put4xi>" 
               
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
      
        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2000ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one20004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time
        
    except:
        print(" (STEP 3C/33) OF FIRE2000ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2000ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2000one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
